package world;

import java.awt.*;
import java.util.*;
import board.*;


//
// do not modify
//
public class World {
	
	public static Arm arm;
	
	static Target target;
	
	static ArrayList<Wall> walls = new ArrayList<Wall>();
	
	static {
		practice();
	}
	
	static public void paint(Graphics g){
		arm.tick();
		
		
		arm.paint(g);
		for(Wall wall : walls)
			wall.paint(g);
		target.paint(g);
		
	}
	
	static boolean detect_collision(){
		arm.compute_joint_positions();
		
		for(Wall wall : walls){
			for(int i=0; i<arm.N; i++){
				if (Vector2D.distance(wall.position, arm.joint_positions[i])<wall.r+arm.R)
					return true;;
			}
		}
		for(int i=0; i<arm.N-1; i++){
			for(int j=i+1; j<arm.N; j++){
				if (Vector2D.distance(arm.joint_positions[i], arm.joint_positions[j])<arm.R+arm.R)
				return true;;
			}		
		}
		
		return false;
	}
	public static boolean target_reached(){
		return (Vector2D.distance(World.target.position, World.arm.get_joint_position(World.arm.N-1)) <
				World.target.R + World.arm.R);
	}
	
	public static void practice(){
		arm = new Arm();
		target = new Target(new Vector2D(400-160,300));
		walls = new ArrayList<Wall>();
		walls.add(new Wall(new Vector2D(400+320,300-100),60));
	}
	public static void task1(){
		arm = new Arm();
		target = new Target(new Vector2D(400-260,300));
		walls = new ArrayList<Wall>();
		walls.add(new Wall(new Vector2D(400-160,300),60));
	}
	public static void task2(){
		arm = new Arm();
		target = new Target(new Vector2D(400-320,300));
		walls = new ArrayList<Wall>();
		walls.add(new Wall(new Vector2D(400,300-200),100));
		walls.add(new Wall(new Vector2D(400,300+200),100));
	}
	public static void task3(){
		arm = new Arm();
		target = new Target(new Vector2D(400-260,300-120));
		walls = new ArrayList<Wall>();
		walls.add(new Wall(new Vector2D(400-120,300-130),80));
		walls.add(new Wall(new Vector2D(400-120,300+130),80));
		walls.add(new Wall(new Vector2D(400-320,300    ),80));
	}
}
